AESFastEngine (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.crypto.engines

## Class AESFastEngine

- java.lang.Object
- - org.bouncycastle.crypto.engines.AESFastEngine

- All Implemented Interfaces:
    BlockCipher

  Deprecated.
  unfortunately this class is has a few side channel issues. In an environment where encryption/decryption may be closely observed it should not be used.

      public class AESFastEngine
      extends java.lang.Object
      implements BlockCipher

  an implementation of the AES (Rijndael), from FIPS-197.

  For further details see: https://csrc.nist.gov/encryption/aes/. This implementation is based on optimizations from Dr. Brian Gladman's paper and C code at https://fp.gladman.plus.com/cryptography_technology/rijndael/ There are three levels of tradeoff of speed vs memory Because java has no preprocessor, they are written as three separate classes from which to choose The fastest uses 8Kbytes of static tables to precompute round calculations, 4 256 word tables for encryption and 4 for decryption. The middle performance version uses only one 256 word table for each, for a total of 2Kbytes, adding 12 rotate operations per round to compute the values contained in the other tables from the contents of the first The slowest version uses no static tables at all and computes the values in each round

  This file contains the fast version with 8Kbytes of static tables for round precomputation.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AESFastEngine()` Deprecated. default constructor - 128 bit block size.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getAlgorithmName()` Deprecated. Return the name of the algorithm the cipher implements.
    `int` | `getBlockSize()` Deprecated. Return the block size for this cipher (in bytes).
    `void` | `init(boolean forEncryption, CipherParameters params)` Deprecated. initialise an AES cipher.
    `int` | `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Deprecated. Process one block of input from the array in and write it to the out array.
    `void` | `reset()` Deprecated. Reset the cipher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AESFastEngine

          public AESFastEngine()

      Deprecated.
      default constructor - 128 bit block size.

  - ### Method Detail

    - #### init

          public void init(boolean forEncryption,
                           CipherParameters params)

      Deprecated.
      initialise an AES cipher.
      Specified by:
        `init` in interface `BlockCipher`
      Parameters:
        `forEncryption` - whether or not we are for encryption.
        `params` - the parameters required to set up the cipher.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Deprecated.
      Description copied from interface: `BlockCipher`
      Return the name of the algorithm the cipher implements.
      Specified by:
        `getAlgorithmName` in interface `BlockCipher`
      Returns:
        the name of the algorithm the cipher implements.

    - #### getBlockSize

          public int getBlockSize()

      Deprecated.
      Description copied from interface: `BlockCipher`
      Return the block size for this cipher (in bytes).
      Specified by:
        `getBlockSize` in interface `BlockCipher`
      Returns:
        the block size for this cipher in bytes.

    - #### processBlock

          public int processBlock(byte[] in,
                                  int inOff,
                                  byte[] out,
                                  int outOff)

      Deprecated.
      Description copied from interface: `BlockCipher`
      Process one block of input from the array in and write it to the out array.
      Specified by:
        `processBlock` in interface `BlockCipher`
      Parameters:
        `in` - the array containing the input data.
        `inOff` - offset into the in array the data starts at.
        `out` - the array the output data will be copied into.
        `outOff` - the offset into the out array the output will start at.
      Returns:
        the number of bytes processed and produced.

    - #### reset

          public void reset()

      Deprecated.
      Description copied from interface: `BlockCipher`
      Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).
      Specified by:
        `reset` in interface `BlockCipher`